<?php
/* vim: set expandtab tabstop=2 shiftwidth=2: */

require_once('common_constructor.php');

function default_constructor(&$win, &$rec, $field_name, $attr1, $attr2) {

  $data = common_constructor($win, $rec, $field_name, $attr1, $attr2);

	if (!$attr1) {

		if (strstr($field_name, 'PRICE') || strstr($field_name, 'COUNT')) {
      if (is_numeric($rec[$field_name])) {
			  $data = number_format(util::str2number($rec[$field_name]));
      } else if ($rec[$field_name]) {
				$data = $rec[$field_name];
      }
		}

		else if (strstr($field_name, 'DATETIME') || strstr($field_name, 'INSERT_DATE') || strstr($field_name, 'MODIFY_DATE')) {
			if ($rec[$field_name] && $rec[$field_name] != '0') {
				$data = util::str2datetime($rec[$field_name]);
			} else {
				$data = "";
			}
		}

		else if (strstr($field_name, 'DATE') || strstr($field_name, 'DAY')) {
			if ($rec[$field_name] && $rec[$field_name] != '0') {
				$data = util::str2date($rec[$field_name]);
			} else {
				$data = "";
			}
		}
  }

	return $data;
}
?>
