<?
echo "covarage.php start<br>";
include('_config/define.php');

$APP_DIR = APP_DIR;
$LOG_DIR = LOG_DIR;

$debug_list = array();

if (file_exists("$LOG_DIR/coverage.flow")) {
  $fp = fopen("$LOG_DIR/coverage.flow", "r");
  while($line = fgets($fp)) {
    if (preg_match('/# (.*?) :: (.*?)$/', $line, $match)) {
      $fn = trim($match[1]);
      $debug_list[$fn]['.'] = trim($match[2]);
    } else if (preg_match('/@@@@@@ (.*?)\t(.*?)$/', $line, $match)) {
      $label = trim($match[1]);
      $debug_list[$fn][$label] = trim($match[2]);
    }
  }
  pclose($fp);
}

$fp = popen("find $APP_DIR -name \*.php", "r");
while($line = fgets($fp)) {
  $fn = realpath(trim($line));  
  if (!$debug_list[$fn]) {
    $debug_list[$fn]['.'] = strftime('%Y/%m/%d %H:%M:%S', filemtime($fn));
  }
}
pclose($fp);

$fp = popen("grep -R ____\( $APP_DIR", "r");
while($line = fgets($fp)) {
  if (preg_match('/(.*?):.*____\(.(.*?).\)/', $line, $match)) {
    $fn = realpath(trim($match[1]));  
    $label = trim($match[2]);
    if (!$debug_list[$fn][$label]) {
      $debug_list[$fn][$label] = '--------';
    }
  }
}
pclose($fp);

$fp = fopen("$LOG_DIR/coverage.flow", "w");
ksort($debug_list);
foreach($debug_list as $fn => $tmp) {
  fwrite($fp, "# $fn :: {$tmp['.']}\n");
  foreach($tmp as $key => $val) {
    if ($key == '.') continue;
    fwrite($fp, "\t@@@@@@ $key\t$val\n");
  }
}
fclose($fp);

////////////////////////////////////////

$TEMPLATE_DIR = TEMPLATE_DIR;
$LOG_DIR = LOG_DIR;

$debug_list = array();

if (file_exists("$LOG_DIR/coverage.action")) {
  $fp = fopen("$LOG_DIR/coverage.action", "r");
  while($line = fgets($fp)) {
    if (preg_match('/# (.*?) :: (.*?)$/', $line, $match)) {
      $fn = trim($match[1]);
      $debug_list[$fn]['.'] = trim($match[2]);
    } else if (preg_match('/@@@@@@ (.*?)\t(.*?)$/', $line, $match)) {
      $label = trim($match[1]);
      $debug_list[$fn][$label] = trim($match[2]);
    }
  }
  pclose($fp);
}

$fp = popen("find $TEMPLATE_DIR -name \*.html", "r");
while($line = fgets($fp)) {
  $fn = realpath(trim($line));  
  if (strstr($fn, '/cache/')) continue;
  if (!$debug_list[$fn]) {
    $debug_list[$fn]['.'] = strftime('%Y/%m/%d %H:%M:%S', filemtime($fn));
  }
}
pclose($fp);

foreach($debug_list as $fn => $tmp) {
  $html = join('', file($fn));
  preg_match_all('/_ACTION\[.*?\]/', $html, $match);
  if ($match[0]) foreach($match[0] as $action) {
    if (strstr($action, '::')) {
      list($tmp1, $tmp2) = split('::', $action);
      $action = "$tmp1::$tmp2::xxx]";
    }
    if (!$debug_list[$fn][$action]) $debug_list[$fn][$action] = '--------';
  }
  preg_match_all('/_ACTION_HISTORY_BACK\[.*?\]/', $html, $match);
  if ($match[0]) foreach($match[0] as $action) {
    if (!$debug_list[$fn][$action]) $debug_list[$fn][$action] = '--------';
  }
  preg_match_all('/_REFRESH/', $html, $match);
  if ($match[0]) foreach($match[0] as $action) {
    if (!$debug_list[$fn][$action]) $debug_list[$fn][$action] = '--------';
  }
  preg_match_all("/_ACTION_.value='.*?'/", $html, $match);
  if ($match[0]) foreach($match[0] as $action) {
    if (strstr($action, '::')) {
      list($tmp1, $tmp2) = split('::', $action);
      $action = "$tmp1::$tmp2::xxx'";
    }
    if (!$debug_list[$fn][$action]) $debug_list[$fn][$action] = '--------';
  }
  preg_match_all('/_ACTION_.value=".*?"/', $html, $match);
  if ($match[0]) foreach($match[0] as $action) {
    $action = preg_replace('"', "'", $action);
    if (strstr($action, '::')) {
      list($tmp1, $tmp2) = split('::', $action);
      $action = "$tmp1::$tmp2::xxx'";
    }
    if (!$debug_list[$fn][$action]) $debug_list[$fn][$action] = '--------';
  }
}

$fp = fopen("$LOG_DIR/coverage.action", "w");
ksort($debug_list);
foreach($debug_list as $fn => $tmp) {
  fwrite($fp, "# $fn :: {$tmp['.']}\n");
  foreach($tmp as $key => $val) {
    if ($key == '.') continue;
    fwrite($fp, "\t@@@@@@ $key\t$val\n");
  }
}
fclose($fp);

echo "covarage.php end<br>";
?>
