--
-- Table structure for table 'tbl_APP1'
--

CREATE TABLE tbl_APP1 (
  APP1_ID int(11) NOT NULL auto_increment,
  APP1_NAME varchar(32) default NULL,
  APP1_PRICE int(11) default NULL,
  APP1_MEMO longtext,
  APP1_DATA_TYPE1_ID varchar(8) default NULL,
  APP1_DATA_TYPE2_ID varchar(8) default NULL,
  APP1_DATA_TYPE3_ID varchar(8) default NULL,
  INSERT_DATE datetime default NULL,
  INSERT_STF varchar(32) default NULL,
  MODIFY_DATE datetime default NULL,
  MODIFY_STF varchar(32) default NULL,
  REMOTE_ADDR varchar(255) default NULL,
  USER_AGENT varchar(255) default NULL,
  PRIMARY KEY  (APP1_ID)
) TYPE=MyISAM;

--
-- Dumping data for table 'tbl_APP1'
--


INSERT INTO tbl_APP1 VALUES (6,'rec6',678901,'쥳6','1','3','1','2005-07-24 19:35:21','',NULL,NULL,'210.143.195.218','Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.0; .NET CLR 1.1.4322; .NET CLR 1.0.3705)');
INSERT INTO tbl_APP1 VALUES (5,'rec5',456789,'쥳5','1','1','1','2005-07-24 19:26:06','','2005-07-24 19:34:46','','210.143.195.218','Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.0; .NET CLR 1.1.4322; .NET CLR 1.0.3705)');
INSERT INTO tbl_APP1 VALUES (3,'rec3',123456,'쥳3','0','3','3','2005-07-24 19:22:29','','2005-07-24 19:33:58','','210.143.195.218','Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.0; .NET CLR 1.1.4322; .NET CLR 1.0.3705)');

--
-- Table structure for table 'tbl_APP2'
--

CREATE TABLE tbl_APP2 (
  APP2_ID int(11) NOT NULL auto_increment,
  APP2_NAME varchar(32) default NULL,
  APP2_PRICE int(11) default NULL,
  APP2_MEMO longtext,
  APP2_DATA_TYPE1_ID varchar(8) default NULL,
  APP2_DATA_TYPE2_ID varchar(8) default NULL,
  APP2_DATA_TYPE3_ID varchar(8) default NULL,
  INSERT_DATE datetime default NULL,
  INSERT_STF varchar(32) default NULL,
  MODIFY_DATE datetime default NULL,
  MODIFY_STF varchar(32) default NULL,
  REMOTE_ADDR varchar(255) default NULL,
  USER_AGENT varchar(255) default NULL,
  PRIMARY KEY  (APP2_ID)
) TYPE=MyISAM;

--
-- Dumping data for table 'tbl_APP2'
--


INSERT INTO tbl_APP2 VALUES (1,'rec1',0,'쥳1','0','1','1','2005-07-24 19:31:01','','2005-07-25 02:46:32','','210.143.195.218','Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.0; .NET CLR 1.1.4322; .NET CLR 1.0.3705)');
INSERT INTO tbl_APP2 VALUES (2,'rec2',0,'쥳2','1','2','2','2005-07-24 19:31:01','','2005-07-25 02:46:32','','210.143.195.218','Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.0; .NET CLR 1.1.4322; .NET CLR 1.0.3705)');
INSERT INTO tbl_APP2 VALUES (3,'rec3',0,'쥳3','0','3','3','2005-07-24 19:31:01','','2005-07-25 02:46:32','','210.143.195.218','Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.0; .NET CLR 1.1.4322; .NET CLR 1.0.3705)');

--
-- Table structure for table 'tbl_DATA_TYPE3'
--

CREATE TABLE tbl_DATA_TYPE3 (
  DATA_TYPE3_ID varchar(32) NOT NULL default '',
  DATA_TYPE3_NAME varchar(32) default NULL,
  INSERT_DATE datetime default NULL,
  INSERT_STF varchar(32) default NULL,
  MODIFY_DATE datetime default NULL,
  MODIFY_STF varchar(32) default NULL,
  REMOTE_ADDR varchar(255) default NULL,
  USER_AGENT varchar(255) default NULL,
  PRIMARY KEY  (DATA_TYPE3_ID)
) TYPE=MyISAM;

--
-- Dumping data for table 'tbl_DATA_TYPE3'
--


INSERT INTO tbl_DATA_TYPE3 VALUES ('1','AAA',NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO tbl_DATA_TYPE3 VALUES ('2','BBB',NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO tbl_DATA_TYPE3 VALUES ('3','CCC',NULL,NULL,NULL,NULL,NULL,NULL);

--
-- Table structure for table 'tbl_LOGIN'
--

CREATE TABLE tbl_LOGIN (
  LOGIN_ID varchar(32) NOT NULL default '',
  LOGIN_PASS varchar(32) default NULL,
  LOGIN_NAME varchar(32) default NULL,
  INSERT_DATE datetime default NULL,
  INSERT_STF varchar(32) default NULL,
  MODIFY_DATE datetime default NULL,
  MODIFY_STF varchar(32) default NULL,
  REMOTE_ADDR varchar(255) default NULL,
  USER_AGENT varchar(255) default NULL,
  PRIMARY KEY  (LOGIN_ID)
) TYPE=MyISAM;

--
-- Dumping data for table 'tbl_LOGIN'
--


INSERT INTO tbl_LOGIN VALUES ('demo','demo','ǥ桼',NULL,NULL,NULL,NULL,NULL,NULL);

