<?php
/* vim: set expandtab tabstop=2 shiftwidth=2: */

function common_constructor(&$win, &$rec, $field_name, $attr1, $attr2) {

	if (!is_array($rec)) $rec = array();

	if (strstr($field_name, 'ERRSTR')) return;

	$data = htmlspecialchars(trim($rec[$field_name]));
  if ($field_name[0] == '_') {
    $data = $rec[$field_name];
  } else {
    if (!array_key_exists($field_name, $rec)) {
      $data = "\x01\x01\x01\x01";
    }
  }

	if ($attr1 == 'radio_checked') {
    if ($attr2 == $rec[$field_name]) {
      $data = 'checked';
    }
	} else if ($attr1 == 'checkbox_checked') {
    if ($attr2 == $rec[$field_name]) {
      $data = 'checked';
    }
	} else if ($attr1 == 'option_selected') {
    if ($attr2 == $rec[$field_name]) {
      $data = 'selected';
    }
	} else if ($attr1 == 'hidden') {
		$data = str_repeat('*', strlen($rec[$field_name]));
	} else if ($attr1 == 'nl2br') {
	  $data = nl2br(htmlspecialchars(trim($rec[$field_name])));
	} else if ($attr1 == 'raw') {
		$data = $rec[$field_name];
    $tmp = $win->_CONTROL_URL;
    $data = str_replace('_CONTROL_URL', $tmp, $data);
	} else if ($attr1 == 'select' || $attr1 == 'select_search') {
		if ($attr1 == 'select') {
			$srch_fg = false;
		} else {
			$srch_fg = true;
		} 

		if (strstr($field_name, 'PER_PAGE')) {
      global $dict_per_page;
			$data = util::make_options($dict_per_page, $rec[$field_name], $srch_fg);
		}

		if (strstr($field_name, 'DATA_TYPE1_ID')) {
      global $dict_data_type1;
			$data = util::make_options($dict_data_type1, $rec[$field_name], $srch_fg);
		}

		if (strstr($field_name, 'DATA_TYPE2_ID')) {
      global $dict_data_type2;
			$data = util::make_options($dict_data_type2, $rec[$field_name], $srch_fg);
		}

		if (strstr($field_name, 'DATA_TYPE3_ID')) {
      global $dict_data_type3;
      if (!$dict_data_type3) {
        $dict_data_type3 = pm9db::select_assoc('select DATA_TYPE3_ID, DATA_TYPE3_NAME from tbl_DATA_TYPE3 order by DATA_TYPE3_ID');
      }
			$data = util::make_options($dict_data_type3, $rec[$field_name], $srch_fg);
		}

	} else if ($attr1 == 'dict') {
		if (strstr($field_name, 'DATA_TYPE1_ID')) {
      global $dict_data_type1;
			$data = $dict_data_type1[$rec[$field_name]];
		}

		if (strstr($field_name, 'DATA_TYPE2_ID')) {
      global $dict_data_type2;
			$data = $dict_data_type2[$rec[$field_name]];
		}

		if (strstr($field_name, 'DATA_TYPE3_ID')) {
			$data = pm9db::select_item("select DATA_TYPE3_NAME from tbl_DATA_TYPE3 where DATA_TYPE3_ID = '{$rec[$field_name]}'");
		}

  }

  return $data;
}
?>
